package com.example.testgrid;

import com.example.testgrid.widgetset.client.TextFieldValChangeRPC;
import com.vaadin.data.Container.Indexed;
import com.vaadin.ui.Grid.AbstractRenderer;

public class TextFieldRenderer<T> extends AbstractRenderer<T> {
	private static final long serialVersionUID = 1L;

	protected TextFieldRenderer(Class<T> arg0) {
		super(arg0);
		registerRpc(new TextFieldValChangeRPC() {
			private static final long serialVersionUID = 1L;

			@Override
			public void valChange(String propID, String index, String newValue) {
				Indexed cont = getParentGrid().getContainerDataSource();
				cont.getItem(cont.getItemIds().toArray()[Integer.valueOf(index)]).getItemProperty(cont.getContainerPropertyIds().toArray()[Integer.valueOf(propID)]).setValue(newValue);
			}
		});
	}
}
