package com.example.testgrid.widgetset.client;

import com.example.testgrid.TestGridExt;
import com.google.gwt.event.dom.client.KeyDownEvent;
import com.google.gwt.event.dom.client.KeyDownHandler;
import com.google.gwt.user.client.Timer;
import com.vaadin.client.ServerConnector;
import com.vaadin.client.connectors.GridConnector;
import com.vaadin.client.extensions.AbstractExtensionConnector;
import com.vaadin.client.widgets.Grid;
import com.vaadin.shared.ui.Connect;

import elemental.json.JsonObject;

@Connect(TestGridExt.class)
public class TestGridExtConn extends AbstractExtensionConnector {
	private static final long serialVersionUID = 1L;
	@Override
	protected void extend(ServerConnector target) {
		GridConnector gridcon = (GridConnector) target;
		final Grid<JsonObject> gr = gridcon.getWidget();
		gr.addDomHandler(new KeyDownHandler() {
			
			@Override
			public void onKeyDown(KeyDownEvent event) {
				if(event.getNativeKeyCode()==40){
					selectFocused();
				}else if(event.getNativeKeyCode()==38){
					selectFocused();
				}
			}
		}, KeyDownEvent.getType());
	}
	public static void selectFocused(){
		Timer t = new Timer() {
			
			@Override
			public void run() {
				execClick();
			}
		};
		t.schedule(10);
	}
	public static native void execClick()  /*-{
  		$wnd.$(".v-grid-cell-focused").click();
	}-*/;
}
