package com.example.testgrid;

import java.util.ArrayList;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.event.ItemClickEvent;
import com.vaadin.event.ItemClickEvent.ItemClickListener;
import com.vaadin.event.ShortcutAction.KeyCode;
import com.vaadin.event.ShortcutListener;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Grid;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("testgrid")
public class TestgridUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = TestgridUI.class, widgetset = "com.example.testgrid.widgetset.TestgridWidgetset")
	public static class Servlet extends VaadinServlet {
	}
	@Override
    protected void init(VaadinRequest vaadinRequest) {
        final VerticalLayout layout = new VerticalLayout();
        layout.setMargin(true);
        setContent(layout);

        ArrayList<ComplexModuleData> complexes = new ArrayList<>();
        ComplexModuleData data = new ComplexModuleData();
        complexes.add(data);
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        complexes.add(new ComplexModuleData());
        BeanItemContainer<ComplexModuleData> container = new BeanItemContainer<>(ComplexModuleData.class, complexes);
        final Grid complexGrid = new Grid(container);

        complexGrid.getColumn(complexGrid.getColumns().get(0).getPropertyId())
        .setRenderer(new TextFieldRenderer(String.class) );

        new TestGridExt().extend(complexGrid);
        layout.addComponent(complexGrid);
    }

}